// ENSAM 2005
// Workshop Infographie du 14/11 au 18/11
// Maison zHome
// macros escalier

#macro volee( p, l, g, e )
	#local h = 1.20/7;
	union
	{	prism
		{	0, -l, 33, 
			<0, 	0>, 
			<p+0*g, 0*h>, <p+0*g, 1*h>,
			<p+1*g, 1*h>, <p+1*g, 2*h>,
			<p+2*g, 2*h>, <p+2*g, 3*h>,
			<p+3*g, 3*h>, <p+3*g, 4*h>,
			<p+4*g, 4*h>, <p+4*g, 5*h>,
			<p+5*g, 5*h>, <p+5*g, 6*h>,
			<p+6*g, 6*h>, <p+6*g, 7*h>,
			<2*p+6*g, 7*h>, <2*p+6*g, 7*h-e>,
			<p+6*g+e, 7*h-e>, <p+6*g+e, 6*h-e>,
			<p+5*g+e, 6*h-e>, <p+5*g+e, 5*h-e>,
			<p+4*g+e, 5*h-e>, <p+4*g+e, 4*h-e>,
			<p+3*g+e, 4*h-e>, <p+3*g+e, 3*h-e>,
			<p+2*g+e, 3*h-e>, <p+2*g+e, 2*h-e>,
			<p+1*g+e, 2*h-e>, <p+1*g+e, 1*h-e>,
			<p+0*g+e, 1*h-e>, <p+0*g+e, 0*h-e>,
			<0, 	0-e>, <0, 	0>
		}
		#if (!DEBUG)
			spot( <p/2, -l/2, -e*1.01> )
			spot( <p+6*g+p/2, -l/2, 7*h-e*1.01> )
		#end
		rotate <-90,0,0>
	}
#end

#macro volee_double()
	union
	{	object { 	volee( 1.20, 0.90, 0.30, 0.10 ) }
		object { 	volee( 1.20, 1.80, 0.30, 0.10 ) 
					rotate <0,180,0>
					translate <4.20,1.20,0> }
	}
#end

#macro garde_corps( h )
	object
	{	polygon { 5, <0, 0>, <1.80, 0>, <1.80, h>, <0, h>, <0,0> }
		translate <1.20,0,0>
		verre()
	}
#end

#macro escalier()
	union
	{	union
		{	object { volee_double() translate <0,0.00,0> }
			object { volee_double() translate <0,2.40,0> }
			object { volee_double() translate <0,4.80,0> }
			object { volee_double() translate <0,7.20,0> }
			lamelle()
		}
		garde_corps( 10.80 )
		translate <-2.10, -1.20, 0>
	}
#end

