// ENSAM 2005
// Workshop Infographie du 14/11 au 18/11
// Maison zHome
// macros interface de visualisation

#declare OX 	= 1;
#declare OY 	= 2;
#declare OZ 	= 3;
#declare AXO_1 	= 4;
#declare AXO_2 	= 5;
#declare AXO_3 	= 6;
#declare AXO_4 	= 7;
#declare PERS 	= 8;

#macro axono( choix, taille, cible )
	#switch (choix)
		#case (OX)
			camera { orthographic location <-1,0,0> right <RATIO,0,0> look_at <0, 0, 0> scale 1/taille translate cible }
		#break
		#case (OY)
			camera { orthographic location <0,1,0> right <RATIO,0,0> look_at <0, 0, 0> scale 1/taille translate cible }
		#break
		#case (OZ)
			camera { orthographic location <0,0,-1> right <RATIO,0,0> look_at <0, 0, 0> scale 1/taille translate cible }
		#break
		#case (AXO_1)
			camera { orthographic location <-1,1,-1> right <RATIO,0,0> look_at <0, 0, 0> scale 1/taille translate cible }
		#break
		#case (AXO_2)
			camera { orthographic location < 1,1,-1> right <RATIO,0,0> look_at <0, 0, 0> scale 1/taille translate cible }
		#break
		#case (AXO_3)
			camera { orthographic location < 1,1, 1> right <RATIO,0,0> look_at <0, 0, 0> scale 1/taille translate cible }
		#break
		#case (AXO_4)
			camera { orthographic location <-1,1, 1> right <RATIO,0,0> look_at <0, 0, 0> scale 1/taille translate cible }
		#break
	#end
#end

#macro pers( oeil, cible )
	camera { location oeil right <RATIO,0,0> look_at cible }
#end

#macro axes()
	cylinder { <-10,0,0>, <10,0,0>, 0.02 pigment { color rgb <1,0,0> } }
	cylinder { <0,-10,0>, <0,10,0>, 0.02 pigment { color rgb <0,1,0> } }
	cylinder { <0,0,-10>, <0,0,10>, 0.02 pigment { color rgb <0,0,1> } }
#end

#macro visu_helicoidale( uu, r, h0, h1, cible )
	#local oeil = < r*cos( 2*pi*uu + pi/4 ), 
					(1-uu)*h0 + uu*h1 , 
					r*sin( 2*pi*uu + pi/4 ) >;
	pers( oeil, cible )	
#end